# frozen_string_literal: true

module Hermes
  # Nud serializer
  class LogSerializer < Hermes::ApplicationSerializer
    cache key: proc { "#{object.cache_key}" }, expires_in: 1.day
    attributes %i[
      id
      created_at
      updated_at
      code
      read_level
      user_id
      action
      current_user_id
      applicant_id
      housing_offer_id
      housing_request_id
      housing_application_id
    ]
  
    type 'logs'
  
    def current_user_id
      object&.current_user_id.to_s
    end

    def applicant_id
      object&.applicant_id.to_s
    end

    def housing_offer_id
      object&.housing_offer_id.to_s
    end

    def housing_request_id
      object&.housing_request_id.to_s
    end

    def user_id
      object&.user_id.to_s
    end

    def housing_application_id
      object&.housing_application_id.to_s
    end
  
    def read_level
      "read"
    end
  end
end
