
require 'csv'

raise 'You need to load this script througth a require' unless __FILE__
# Replace following variables if need
FILE_TYPE = 'csv'
FILE_PATH = "."
def run_script(skip)
  start_time = Time.now
  formated_t = start_time.strftime('%d-%m-%Y-%H:%M')
  puts "Start script at #{start_time}"
  file_name   = "#{HERMES_CONFIG['environment']}-#{formated_t}-#{__FILE__.split('/').last.gsub('.rb', ".#{FILE_TYPE}")}"
  file_class  = FILE_TYPE == 'csv' ? CSV : File
  file        = file_class.open("#{FILE_PATH}/#{file_name}", 'ab')
  ##############################################################################
  ##################################__SCRIPT__##################################
  # write the content of the script bellow
  file << [
    "housing_request_id",
    "active_application_housing_offer_id avant",
    "active_application_housing_offer_id après"
  ]
  
  housing_requests = Hermes::HousingRequest.where({ active_application_id: nil, active_application_housing_offer_id: { :$ne => nil } })
  count = housing_requests.count

  puts("#{count} housing request with (active_application_id == null) && (active_application_housing_offer_id != null) found")
  housing_requests.batch_size(5).each_with_index do |housing_request, i|
    begin
      puts "#{i+1}/#{count}"

      active_application_housing_offer_id_before = housing_request.active_application_housing_offer_id
      housing_request.active_application_housing_offer_id = nil
      housing_request.save
      line = [
        housing_request.id.to_s,
        active_application_housing_offer_id_before,
        housing_request.active_application_housing_offer_id,
      ]
      file << line
      puts line.join(', ')

    rescue Exception => e
      line = ["Erreur de traitement : #{e}"]
      file << [line]
      puts line.join(', ')
    end
  end 
  ##############################################################################
  ##############################################################################
  file.close
  stop_time = Time.now
  puts "Start end at #{stop_time}"
  puts "Executed in #{(stop_time - start_time).seconds}"
end

run_script( 0)